/*
 * Copyright 2008- kensir0u.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
/*
 * 쐬       F2008/11/05
 * pbP[W   Fikdnet.dijava
 * t@C   FMain.java
 */
package ikdnet.dijava;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.tools.Diagnostic;
import javax.tools.DiagnosticCollector;
import javax.tools.FileObject;
import javax.tools.ForwardingJavaFileManager;
import javax.tools.JavaCompiler;
import javax.tools.JavaFileManager;
import javax.tools.JavaFileObject;
import javax.tools.SimpleJavaFileObject;
import javax.tools.StandardJavaFileManager;
import javax.tools.ToolProvider;
import javax.tools.JavaCompiler.CompilationTask;
import javax.tools.JavaFileObject.Kind;

/**
 * <i>Tv</i>F DIJavaCNX @.
 * <p>
 * DIJavaCNX
 * 
 * 
 * @author kensir0u
 * @version 1.0
 * @since JDK 5.0
 * 
 */
public class Main {

	/**
	 * <i>Tv</i>F \[Xi[}bv
	 * .<p>
	 * \[Xi[}bv
	 *
	 */
	private static Map<String, JavaSource> src = new LinkedHashMap<String, JavaSource>();

	/**
	 * <i>Tv</i>F DIJava[h .
	 * <p>
	 * DIJava[h
	 * 
	 */
	private static int mode = 1;

	/**
	 * 
	 * <i>Tv</i>F URIIuWFNg̐ .
	 * <p>
	 * URIIuWFNg̐ @
	 * 
	 * @param name
	 * @return@URIIuWFNg
	 */
	private static URI toURI(String name) {
		try {
			return new URI(name);
		} catch (URISyntaxException e) {
			throw new RuntimeException(e);
		}
	}

	/**
	 * 
	 * <i>Tv</i>F Javat@CIuWFNgINX @.
	 * <p>
	 * Javat@CIuWFNgINX
	 * 
	 * 
	 * @author kensir0u
	 * @version 1.0
	 * @since JDK 5.0
	 * 
	 */
	static class MemoryJavaFileObject extends SimpleJavaFileObject {

		/**
		 * <i>Tv</i>F t@CIuWFNgoCgXg[ .
		 * <p>
		 * t@CIuWFNgoCgXg[
		 * 
		 */
		ByteArrayOutputStream baos;

		/**
		 * 
		 * <i>Tv</i>F t@ĆAt@Cʂݒ .
		 * <p>
		 * t@ĆAt@Cʂݒ @
		 * 
		 * @param name
		 * @param kind
		 */
		MemoryJavaFileObject(String name, Kind kind) {
			super(toURI(name), kind);
		}

		@Override
		public CharSequence getCharContent(boolean ignoreEncodingErrors)
				throws IOException, IllegalStateException,
				UnsupportedOperationException {
			throw new UnsupportedOperationException();
		}

		@Override
		public InputStream openInputStream() throws IOException,
				IllegalStateException, UnsupportedOperationException {
			return new ByteArrayInputStream(baos.toByteArray());
		}

		@Override
		public OutputStream openOutputStream() throws IOException,
				IllegalStateException, UnsupportedOperationException {
			return baos = new ByteArrayOutputStream();
		}

	}

	/**
	 * 
	 * <i>Tv</i>F DIJavaC\bh .
	 * <p>
	 * DIJavaC\bh @
	 * 
	 * @param args
	 */
	public static void main(String args[]) {

		// RpC̎擾
		JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();

		if (compiler == null) {
			throw new IllegalStateException(
					"Cannot find the system Java compiler. "
							+ "Check that your class path includes tools.jar");
		}

		final Map<String, JavaFileObject> output = new HashMap<String, JavaFileObject>();

		DiagnosticCollector<JavaFileObject> diagnostics = new DiagnosticCollector<JavaFileObject>();

		JavaFileManager jfm = new ForwardingJavaFileManager<StandardJavaFileManager>(
				compiler.getStandardFileManager(diagnostics, null, null)) {

			@Override
			public JavaFileObject getJavaFileForOutput(Location location,
					String name, Kind kind, FileObject sibling)
					throws IOException {
				JavaFileObject jfo = new MemoryJavaFileObject(name, kind);
				output.put(name, jfo);
				return jfo;
			}

		};

		List<String> list = new ArrayList<String>();
		int count = 0;
		int nest = 0;
		try {

			InputStreamReader in = new InputStreamReader(System.in);
			BufferedReader reader = new BufferedReader(in);
			boolean compile = false;
			String fileName = null;
			List<String> cp = new ArrayList<String>();

			do {
				String mode_title = "(free)";
				if (mode == 0) {
					mode_title = "(free)";
				} else if (mode == 1) {
					mode_title = "(main)";
				} else if (mode == 2) {
					mode_title = "(meth)";
				}
				System.out.print("DIJava:" + mode_title + padding(3, count)
						+ ":" + padding(2, nest) + "> ");
				String command = reader.readLine();
				if ("quit".equals(command.trim())
						|| "exit".equals(command.trim())) {
					System.out.println("see you!");
					System.exit(0);
				}
				if ("version".equals(command.trim())) {
					System.out
							.println("DIJava(Dynamic Interactive Java) -Version \"0.0.3\"");
					continue;
				}

				if ("export".equals(command.trim())) {

					JFileChooser filechooser = new JFileChooser();

					int selected = filechooser.showSaveDialog(new JFrame());
					if (selected == JFileChooser.APPROVE_OPTION) {
						File file = filechooser.getSelectedFile();
						// java.io
						BufferedWriter bufferWriter = null;

						try {
							bufferWriter = new BufferedWriter(
									new OutputStreamWriter(
											new FileOutputStream(file
													.getAbsolutePath(), true),
											"UTF-8"));

							// 
							for (int i = 0; i < list.size(); i++) {
								bufferWriter.write(list.get(i));
								bufferWriter.newLine(); // s
							}

						} catch (Exception e) {
							System.out.println(e.getMessage());
						} finally {
							try {
								if (bufferWriter != null) {
									bufferWriter.close();
								}
							} catch (Exception e) {
							}
						}

					} else if (selected == JFileChooser.CANCEL_OPTION) {

					} else if (selected == JFileChooser.ERROR_OPTION) {

					}
					continue;
				}

				if ("clear".equals(command.trim())) {
					list.clear();
					count = 0;
					nest = 0;
					fileName = null;
					cp.clear();
					continue;
				}
				if (command.startsWith("cat")) {

					if ("cat".equals(command)) {

						for (int j = 0; j < list.size(); j++) {
							System.out.println(padding(3, j) + ":"
									+ list.get(j));
						}

						if (list.size() == 0) {
							System.out.println("code is nothing!");
						}

					} else {

						StringTokenizer commands = new StringTokenizer(command);

						int i = 0;
						while (commands.hasMoreTokens()) {
							if (i == 1) {
								String file_name = commands.nextToken();

								if (src.containsKey(file_name)) {
									JavaSource js = src.get(file_name);
									List<?> l = js.getSource();
									for (int j = 0; j < l.size(); j++) {
										System.out.println(padding(3, j) + ":"
												+ l.get(j));
									}
								} else {

									System.out.println("Not Found File:["
											+ file_name + "]");
								}
								break;
							} else if (i > 1) {
								break;
							}
							i++;
							commands.nextToken();
						}
					}
					continue;
				}

				if (command.startsWith("del")) {

					StringTokenizer commands = new StringTokenizer(command);

					int i = 0;
					while (commands.hasMoreTokens()) {
						if (i == 1) {
							String file_name = commands.nextToken();

							if (src.containsKey(file_name)) {
								src.remove(file_name);
							} else {
								System.out.println("Not Found File:["
										+ file_name + "]");
							}
							break;
						} else if (i > 1) {
							break;
						}
						i++;
						commands.nextToken();

					}
					continue;
				}

				if (command.startsWith("exch")) {

					StringTokenizer commands = new StringTokenizer(command);

					if (commands.countTokens() == 3) {
						commands.nextToken();
						String from = commands.nextToken();
						String to = commands.nextToken();
						char c[] = from.toCharArray();
						boolean error = false;
						for (int x = 0; x < c.length; x++) {
							if (!Character.isDigit(c[x])) {
								System.out.println("Command is wrong![" + from
										+ "]");
								error = true;
								break;
							}
						}

						c = to.toCharArray();

						for (int x = 0; x < c.length; x++) {
							if (!Character.isDigit(c[x])) {
								System.out.println("Command is wrong![" + to
										+ "]");
								error = true;
								break;
							}
						}

						if (error) {
							continue;
						}

						int f = Integer.parseInt(from);
						int t = Integer.parseInt(to);

						if (f >= list.size() || t >= list.size()) {
							System.out.println("Line is wrong![" + f + "],["
									+ t + "] " + "MaxSize:" + list.size());
							continue;
						}

						String bufFrom = list.get(f);
						String bufTo = list.get(t);

						list.set(f, bufTo);
						list.set(t, bufFrom);
					}

					continue;
				}

				if ("list".equals(command.trim())
						|| "ls".equals(command.trim())) {
					if (src.size() == 0) {
						System.out.println("File is not exsits!");
						continue;
					}
					Set<?> s = src.keySet();
					Iterator<?> ite = s.iterator();
					int i = 0;
					while (ite.hasNext()) {
						JavaSource js = src.get(ite.next());
						System.out.println(i + ":" + js.getFile_name() + ":"
								+ js.getPackage_name());
						i++;
					}
					continue;
				}

				if (command.startsWith("mode")) {

					StringTokenizer commands = new StringTokenizer(command);

					int i = 0;
					while (commands.hasMoreTokens()) {
						if (i == 1) {
							String mode_name = commands.nextToken();
							if ("free".equals(mode_name)) {
								if (mode == 0) {
									break;
								}
								list.clear();
								mode = 0;
							} else if ("main".equals(mode_name)) {
								if (mode == 1) {
									break;
								}
								list.clear();
								mode = 1;
							} else if ("meth".equals(mode_name)) {
								if (mode == 2) {
									break;
								}
								list.clear();
								mode = 2;
							}
							break;
						} else if (i > 1) {
							break;
						}
						i++;
						commands.nextToken();
					}
					continue;
				}

				if (command.startsWith("edit")) {

					StringTokenizer commands = new StringTokenizer(command);

					int i = 0;

					if (commands.countTokens() == 3) {
						String co = "";
						String line = "";
						while (commands.hasMoreTokens()) {
							if (i == 0) {
								commands.nextToken();
							}
							if (i == 1) {
								co = commands.nextToken();
							} else if (i == 2) {
								line = commands.nextToken();
								break;
							}
							i++;
						}

						char c[] = line.toCharArray();
						boolean error = false;
						for (int x = 0; x < c.length; x++) {
							if (!Character.isDigit(c[x])) {
								System.out.println("Command is wrong!");
								error = true;
								break;
							}
						}
						if (error) {
							continue;
						}
						if (Integer.parseInt(line) >= list.size()) {
							System.out.println("Line is wrong![" + line + "]"
									+ "MaxSize:" + list.size());
							continue;
						}

						if (co.equals("ins")) {

							System.out.print("DIEdit:" + mode_title
									+ padding(3, Integer.parseInt(line)) + ":"
									+ padding(2, 0) + "> ");
							String line_source = reader.readLine();
							list.add(Integer.parseInt(line), line_source);
							count++;

						} else if (co.equals("upd")) {

							System.out.print("DIEdit:" + mode_title
									+ padding(3, Integer.parseInt(line)) + ":"
									+ padding(2, 0) + "> ");
							String line_source = reader.readLine();
							list.set(Integer.parseInt(line), line_source);

						} else if (co.equals("del")) {
							list.remove(Integer.parseInt(line));
							count--;
						}

					} else if (commands.countTokens() == 4) {
						String co = "";
						String line = "";
						String fileNM = "";
						while (commands.hasMoreTokens()) {
							if (i == 0) {
								commands.nextToken();
							} else if (i == 1) {
								co = commands.nextToken();
							} else if (i == 2) {
								line = commands.nextToken();
							} else if (i == 3) {
								fileNM = commands.nextToken();
								break;
							}
							i++;
						}

						char c[] = line.toCharArray();
						boolean error = false;
						for (int x = 0; x < c.length; x++) {
							if (!Character.isDigit(c[x])) {
								System.out.println("Command is wrong!");
								error = true;
								break;
							}
						}
						if (error) {
							continue;
						}

						if (!src.containsKey(fileNM)) {
							System.out.println("File Not Found![" + fileNM
									+ "]");
							continue;
						}
						JavaSource js = src.get(fileNM);
						List<String> xlist = js.getSource();
						if (Integer.parseInt(line) >= xlist.size()) {
							System.out.println("Line is wrong![" + line + "]"
									+ "MaxSize:" + xlist.size());
							continue;
						}

						if (co.equals("ins")) {

							System.out.print("DIEdit:" + mode_title
									+ padding(3, Integer.parseInt(line)) + ":"
									+ padding(2, 0) + "> ");
							String line_source = reader.readLine();
							xlist.add(Integer.parseInt(line), line_source);
							js.setSource(xlist);
							js.setEditable(true);
							src.put(js.getFile_name(), js);

						} else if (co.equals("upd")) {

							System.out.print("DIEdit:" + mode_title
									+ padding(3, Integer.parseInt(line)) + ":"
									+ padding(2, 0) + "> ");
							String line_source = reader.readLine();
							xlist.set(Integer.parseInt(line), line_source);
							js.setSource(xlist);
							js.setEditable(true);
							src.put(js.getFile_name(), js);

						} else if (co.equals("del")) {

							xlist.remove(Integer.parseInt(line));
							js.setSource(xlist);
							js.setEditable(true);
							src.put(js.getFile_name(), js);

						}

						continue;
					} else {
						System.out.println("Command is wrong!.");
						continue;
					}
					continue;
				}

				if ("help".equals(command.trim()) || "?".equals(command.trim())) {
					printHelp();
					continue;
				}

				// cat [file_name]
				// del [file_name]
				// list
				// start [method] [] [] []...
				// java [file_name]
				// mode [mode](main or meth or free)
				// help
				// edit [command](ins or upd or del) file_name line =>source
				// clear
				// quit
				// help
				if (command.startsWith("java ") || command.equals("java")) {

					StringTokenizer commands = new StringTokenizer(command);

					List<String> a = new ArrayList<String>();
					boolean flg = false;
					while (commands.hasMoreTokens()) {
						if (!flg) {
							commands.nextToken();
							flg = !flg;
						} else {
							a.add(commands.nextToken());
						}
					}

					if (a.size() != 0) {
						args = (String[]) a.toArray(new String[0]);

					}
				} else if (command.startsWith("start")) {

					if (src.size() == 0) {
						System.out.println("Source is nothing!.");

					} else {
						try {
							InvokerUtil.invoke(src, command);
						} catch (Exception e) {
							e.printStackTrace();
						}
					}
					continue;
				} else {
					list.add(command);
					count++;
				}

				List<Token> l = Tokenizer.split(getSource(list));
				if (null == fileName) {
					fileName = Tokenizer.getFileName(l);
				}
				nest = Tokenizer.getNestCount(l);
				if (null == fileName && mode == 0)
					continue;
				List<String> classpath = null;

				if (cp.size() > 0) {
					classpath = new ArrayList<String>();
					classpath.add(" -cp ");
					String path = "";
					for (int cpi = 0; cpi < cp.size(); cpi++) {
						String p = cp.get(cpi);
						if (p != null && !"".equals(p)) {
							path = path + p + ";";
						}
					}
					classpath.add(path);
				}

				List<String> _list = null;
				String _fileName = null;

				if (mode == 0) {
					_list = list;
					_fileName = fileName;
				} else if (mode == 1) {
					_list = new ArrayList<String>(list);
					_list = importDecorate(_list);
					_list.add(8, "public class MAIN{");
					_list.add(9, "  public static void main(String args[]) {");
					_list.add("    }");
					_list.add("}");
					_fileName = "MAIN";

				} else if (mode == 2) {
					_list = new ArrayList<String>(list);
					_list = importDecorate(_list);
					_list.add(8, "public class METHOD{");
					_list.add("}");
					_fileName = "METHOD";
				}

				List<String> clazzs = null;
				if (src.size() > 0) {
					clazzs = new ArrayList<String>();
					Set<?> s = src.keySet();
					Iterator<?> ite = s.iterator();
					while (ite.hasNext()) {
						String key = (String) ite.next();
						if (!key.equals(_fileName)) {
							JavaSource js = src.get(key);
							clazzs.add(js.getPackage_name());
						}
					}

				}

				CompilationTask task = null;
				task = compiler.getTask(null, jfm, diagnostics, classpath,
						clazzs,
						Arrays.asList(new JavaMemoryObject(toURI(_fileName
								+ JavaFileObject.Kind.SOURCE.extension),
								getSource(_list))));
				// RpCs
				compile = task.call();
				// RpCʂ̔f
				if (!compile) {
					if (nest == 0 && _list.size() > 1) {
						for (Diagnostic<?> diagnostic : diagnostics
								.getDiagnostics()) {
							System.out.println("Error:"
									+ diagnostic.getMessage(null));
						}
					}

				} else {

					Set<?> s = output.keySet();
					Iterator<?> ite = s.iterator();
					String clazz = "";
					while (ite.hasNext()) {
						clazz = (String) ite.next();
						if (clazz.endsWith(_fileName)) {
							break;
						}
					}

					src.put(_fileName, new JavaSource(new ArrayList<String>(
							list), clazz, _fileName, classpath));

					ClassLoader cl = new ClassLoader() {
						@Override
						protected Class<?> findClass(String name)
								throws ClassNotFoundException {
							JavaFileObject jfo = output.get(name);
							if (jfo != null) {
								byte[] bytes = ((MemoryJavaFileObject) jfo).baos
										.toByteArray();
								return defineClass(name, bytes, 0, bytes.length);
							}
							return super.findClass(name);
						}
					};

					try {

						Class<?> c = Class.forName(clazz, false, cl);
						Method[] ms = c.getDeclaredMethods();
						boolean mainflg = false;
						for (int i = 0; i < ms.length; i++) {
							String method = ms[i].getName();
							Class<?> clz[] = ms[i].getParameterTypes();
							if ("main".equals(method)
									&& clz[0].isAssignableFrom(String[].class)) {
								mainflg = true;
								break;
							}

						}

						JavaSource js = src.get(_fileName);
						js.setMs(ms);
						js.setMainflg(mainflg);
						js.setC(c);
						src.put(_fileName, js);

						if (mainflg) {
							c.getMethod("main", String[].class).invoke(null,
									new Object[] { args });
						}

					} catch (SecurityException e) {
						e.printStackTrace();
					} catch (IllegalArgumentException e) {
						e.printStackTrace();
					} catch (ClassNotFoundException e) {
						e.printStackTrace();
					} catch (NoSuchMethodException e) {
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						e.printStackTrace();
					} catch (InvocationTargetException e) {
						e.printStackTrace();
					}
					if (mode == 0) {
						list.clear();
						count = 0;
						nest = 0;
						cp.clear();
						fileName = null;
					}
				}
			} while (true);

		} catch (IOException e) {
			System.err.println(e.getMessage());
			System.exit(1);
		}
	}
	
	/**
	 * 
	 * <i>Tv</i>F C|[gǉ
	 * .<p>
	 * C|[gǉB
	 *@
	 * @param _list
	 * @return
	 */
	private static List<String> importDecorate(List<String> _list) {
		_list.add(0, "import java.util.*;");
		_list.add(1, "import javax.swing.*;");
		_list.add(2, "import java.awt.image.*;");
		_list.add(3, "import java.awt.*;");
		_list.add(4, "import java.awt.event.*;");
		_list.add(5, "import java.io.*;");
		_list.add(6, "import java.awt.datatransfer.*;");
		_list.add(7, "import javax.swing.filechooser.*;");
		return _list;
	}

	/**
	 * 
	 * <i>Tv</i>F 0ߏ .
	 * <p>
	 * 0ߏ @
	 * 
	 * @param digit
	 * @param val
	 * @return@0ߏ㕶
	 */
	private static String padding(int digit, int val) {
		return String.format("%0" + digit + "d", val);
	}

	/**
	 * 
	 * <i>Tv</i>F \[XXg\[X𐶐 .
	 * <p>
	 * \[XXg\[X𐶐 @
	 * 
	 * @param list
	 * @return@\[X
	 */
	private static String getSource(List<String> list) {

		String source = "";
		for (String arg : list) {
			source = source + "\n" + arg;
		}
		return source;

	}

	/**
	 * 
	 * <i>Tv</i>F HELP\ .
	 * <p>
	 * HELP\ @
	 */
	private static void printHelp() {
		System.out.println("-------------------------------------------");
		System.out.println("-----DIJava (Dynamic Interactive Java) ----");
		System.out.println("-------------------------------------------");
		System.out.println("This is DIJava commands and reserved words.");
		System.out.println("");
		System.out
				.println("cat [file_name or nothing]. --Display the active code.");
		System.out.println("del [file_name]. --delete file.");
		System.out.println("list or ls   --listing files.");
		System.out.println("java [args...] --execute java.");
		System.out.println("start [method] --execute method.");
		System.out
				.println("edit [command](ins or upd or del) [line] [file_name or nothing] --Modify the code.");
		System.out.println("mode [mode](free or main) --change the mode.");
		System.out.println("exch [from_line] [to_line] --exchange the code.");
		System.out.println("export --export to file.");
		System.out.println("version --display version");
		System.out.println("clear --clear the active code.");
		System.out.println("help or ?");
		System.out.println("quit or exit");

	}
}
